/* 
 * We are not using yet all these
 */

const imgICache                = Components.interfaces.imgICache;
const nsIBrowserDOMWindow      = Components.interfaces.nsIBrowserDOMWindow;
const nsIBrowserHistory        = Components.interfaces.nsIBrowserHistory;
const nsIClipboard             = Components.interfaces.nsIClipboard;
//const nsIDeviceSupport         = Components.interfaces.nsIDeviceSupport;
const nsIDOMChromeWindow       = Components.interfaces.nsIDOMChromeWindow;
const nsIDOMDocument           = Components.interfaces.nsIDOMDocument;
const nsIDOMWindow             = Components.interfaces.nsIDOMWindow;
const nsIDocShellHistory       = Components.interfaces.nsIDocShellHistory;
const nsIDocShellTreeItem      = Components.interfaces.nsIDocShellTreeItem;
const nsIDocShellTreeNode      = Components.interfaces.nsIDocShellTreeNode;
const nsIInterfaceRequestor    = Components.interfaces.nsIInterfaceRequestor;
//const nsIPhoneSupport          = Components.interfaces.nsIPhoneSupport;
const nsIPrefBranch            = Components.interfaces.nsIPrefBranch;
const nsIPrefService           = Components.interfaces.nsIPrefService;
const nsISHistory              = Components.interfaces.nsISHistory;
const nsISupportsString        = Components.interfaces.nsISupportsString;
const nsISupportsWeakReference = Components.interfaces.nsISupportsWeakReference;
const nsITransferable          = Components.interfaces.nsITransferable;
const nsIURIFixup              = Components.interfaces.nsIURIFixup;
const nsIWebNavigation         = Components.interfaces.nsIWebNavigation;
const nsIXULBrowserWindow      = Components.interfaces.nsIXULBrowserWindow;
const nsIWebProgress           = Components.interfaces.nsIWebProgress;
const nsIWebProgressListener   = Components.interfaces.nsIWebProgressListener;
const nsIWebProgressListener2  = Components.interfaces.nsIWebProgressListener2;
const nsIXULWindow             = Components.interfaces.nsIXULWindow;
const nsITransfer              = Components.interfaces.nsITransfer;
const nsIConsoleService        = Components.interfaces.nsIConsoleService;
const nsIComponentRegistrar    = Components.interfaces.nsIComponentRegistrar;
//const nsISoftKeyBoard          = Components.interfaces.nsISoftKeyBoard;
const nsIObserverService       = Components.interfaces.nsIObserverService;
const nsIPrefBranch2           = Components.interfaces.nsIPrefBranch2;
const nsIFile                  = Components.interfaces.nsIFile;
const nsILocalFile             = Components.interfaces.nsILocalFile;
const nsIFilePicker            = Components.interfaces.nsIFilePicker;


var gBrowser = null;
var gURLBar = null;
var gBrowserStatusHandler;
var gGlobalHistory = null;
var gURIFixup = null;
var gZoomFactor = 10;
var gListener = null;

function getAbsolutePosition(element) {
  var r = { left : element.offsetLeft, top: element.offsetTop };
  if (element.offsetParent) {
    var tmp = getAbsolutePosition(element.offsetParent);
    r.left += tmp.left;
    r.top += tmp.top;
  }
  return r;
};

function ZoomController(aBrowser) {
  this.browser = aBrowser;
};

ZoomController.prototype = {
  options: {
    minScale: 0.1,
    maxScale: 10
  },
  set scale(s) {
    var clamp = Math.min(this.options.maxScale, Math.max(this.options.minScale, s));
//    if (clamp > 0.97 && clamp < 1.03)
//      clamp = 1;
    this.browser.markupDocumentViewer.fullZoom = clamp;
  },
  get scale()  {
    return this.browser.markupDocumentViewer.fullZoom;
  },
  fitContent: function() {
  // html has width of the window, and body has width of content
    var body = this.browser.contentWindow.document.body;
    var html = this.browser.contentWindow.document.documentElement;
    var scale = this.browser.markupDocumentViewer.fullZoom;
    var finalWidth = body.clientWidth - 8;
//    dump("WIDTHS: " + "scroll: " + body.scrollWidth + " client" + html.clientWidth + "\n");
    if (body.scrollWidth > html.clientWidth)  // body wider than window, scale id down
    {
      scale = html.clientWidth / body.scrollWidth * this.browser.markupDocumentViewer.fullZoom;
      finalWidth = (body.clientWidth - 8) * this.browser.markupDocumentViewer.fullZoom;
    }
    body.style.minWidth = body.style.maxWidth = finalWidth + "px";
 //   this.options.minScale = Math.max(this.options.minScale, scale);
    this.scale = scale;
//    dump("zoom: " + scale + " finalWidth: " + finalWidth + "\n");
  },
  revealElement: function(el) {
    if (!el) return;
    var r = getAbsolutePosition(el);
    r.width = el.offsetWidth;
    r.height = el.offsetHeight;
  }
};
function startup()
{
  try {
     
   
    gBrowser = document.getElementById("content");
    gBrowser.zoomController = new ZoomController(gBrowser);
    
    gURLBar = document.getElementById("mburlbar");

    var webNavigation;
    try {
        var appCore = Components.classes["@mozilla.org/appshell/component/browser/instance;1"].createInstance(Components.interfaces.nsIBrowserInstance);
        if (!appCore)
            throw "couldn't create a browser instance";

        webNavigation = getWebNavigation();
        if (!webNavigation)
            throw "no XBL binding for browser";
    } 
    catch (e) 
    {
        alert("Error launching browser window:" + e);
        //window.close(); // Give up.
        return;
    }

    gListener = new nsBrowserStatusHandler();

    window.XULBrowserWindow = gListener; 
    window.QueryInterface(nsIInterfaceRequestor)
        .getInterface(nsIWebNavigation)
        .QueryInterface(nsIDocShellTreeItem).treeOwner
        .QueryInterface(nsIInterfaceRequestor)
        .getInterface(nsIXULWindow)
        .XULBrowserWindow = window.XULBrowserWindow;

    window.QueryInterface(nsIDOMChromeWindow).browserDOMWindow = new nsBrowserAccess();

    appCore.setWebShellWindow(window);

    webNavigation.sessionHistory = 
        Components.classes["@mozilla.org/browser/shistory;1"].createInstance(nsISHistory);

    //gBrowser.browsers[0].removeAttribute("disablehistory");
    gBrowser.removeAttribute("disablehistory");

    gBrowser.docShell.QueryInterface(nsIDocShellHistory).useGlobalHistory = true;

    //gGlobalHistory = Components.classes["@mozilla.org/browser/global-history;2"]
    //   .getService(nsIBrowserHistory);

    gBrowser.addProgressListener(gListener, nsIWebProgress.NOTIFY_ALL);
    loadURI("http://wiki.mozilla.org/Mobile/UI/Designs/TouchScreen");
//  loadURI("http://www.digg.com/");
//  loadURI("http://www.totic.org/");
//    loadURI("file:///C:/Documents%20and%20Settings/atotic/Desktop/x.html");
  
  } catch (e) {
    onErrorHandler("Error trying to startup browser.  \n" + e);
  }

}


function onErrorHandler(x)
{
  try {
    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(nsIConsoleService);
    consoleService.logStringMessage(x);
  }
  catch(ex) 
  { 
      alert("onErrorHandler: " + x); 
  }
}

function nsBrowserStatusHandler() {}
nsBrowserStatusHandler.prototype = 
{
  QueryInterface : function(aIID)
  {
    if (aIID.equals(nsIWebProgressListener) ||
        aIID.equals(nsIXULBrowserWindow) ||
        aIID.equals(nsISupportsWeakReference) ||
        aIID.equals(nsISupports))
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },
  
  init : function()
  {
    this.onSecurityChange(null, null, nsIWebProgressListener.STATE_IS_INSECURE);
  },
  
  destroy : function()
  {
  },
  
  onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
  {
    var fs = "";
    if (aStateFlags & nsIWebProgressListener.STATE_START)
      fs += "\t" + "STATE_START";
    if (aStateFlags & nsIWebProgressListener.STATE_REDIRECTING)
      fs += "\t" + " STATE_REDIRECTING";
    if (aStateFlags & nsIWebProgressListener.STATE_TRANSFERRING)
      fs += "\t" + " STATE_TRANSFERRING";
    if (aStateFlags & nsIWebProgressListener.STATE_NEGOTIATING)
      fs += "\t" + " STATE_NEGOTIATING"; 
    if (aStateFlags & nsIWebProgressListener.STATE_STOP)
      fs += "\t" + " STATE_STOP";
      
    if (aStateFlags & nsIWebProgressListener.STATE_IS_REQUEST)
      fs += "\t" + " STATE_IS_REQUEST"; 
    if (aStateFlags & nsIWebProgressListener.STATE_IS_DOCUMENT)
      fs += "\t" + " STATE_IS_DOCUMENT"; 
    if (aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK)
      fs += "\t" + " STATE_IS_NETWORK"; 
    if (aStateFlags & nsIWebProgressListener.STATE_IS_WINDOW)
      fs += "\t" + " STATE_IS_WINDOW"; 


    if (aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK)
    {
    // Certain sites (digg.com), do not give us the STATE_IS_NETWORK/STATE_STOP event
    // still working on debugging this
//      dump("flags " + fs + " " + aRequest.loadFlags + "\n");
      if (aStateFlags & nsIWebProgressListener.STATE_START)
      {
    if(aRequest && aWebProgress.DOMWindow == content) {
          this.startDocumentLoad(aRequest);
    }
      }
      if (aStateFlags & nsIWebProgressListener.STATE_STOP)
      {
        if (aRequest) {
            if (aWebProgress.DOMWindow == content) this.endDocumentLoad(aRequest, aStatus);
        }
      }
    }
  },
  onProgressChange : function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress)
  {
    this.currentTotalProgress = aCurTotalProgress;
    this.maxTotalProgress     = aMaxTotalProgress;

    var percentage = aCurTotalProgress/aMaxTotalProgress;
    
    //document.getElementById("progressbar").value = parseInt(percentage*100)+"%";   

    if (percentage > 0.2)
    {
        document.getElementById("title").value = gBrowser.contentTitle; 
    }
    
  },
  onLocationChange : function(aWebProgress, aRequest, aLocation)
  {

  },
  
  onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage)
  {
      /*
    document.getElementById("statusbar").value= aMessage +
                                                     " (" +
                                                     this.currentTotalProgress +
                                                     "/" +
                                                     this.maxTotalProgress +
                                                     ")";
                                                     */
  },
  startDocumentLoad : function(aRequest)
  {
    document.getElementById("load").image = "image/cancel.png"; 
    document.getElementById("load").command = "cmd_BrowserStop"; 
    document.getElementById("title").value = "Loading...";
    gBrowser.markupDocumentViewer.fullZoom = 1.0;
  },
  endDocumentLoad : function(aRequest, aStatus)
  {
    // fix up the navigation bar
    document.getElementById("load").image = "image/refresh.png"; 
    document.getElementById("load").command = "cmd_BrowserGo";
    gURLBar.value = gBrowser.currentURI.spec;
    // zoom content
    gBrowser.contentWindow.scrollbars.visible = false;
    gBrowser.zoomController.fitContent();
  // initialize scrolling
  browserPan();
  },
  onSecurityChange : function(aWebProgress, aRequest, aState)
  {
  },
  
  setJSStatus : function(status)
  {
  },
  
  setJSDefaultStatus : function(status)
  {
  },
  
  setDefaultStatus : function(status)
  {
  },
  
  setOverLink : function(link, b)
  {
  }
}


function MiniNavShutdown()
{
  if (gBrowserStatusHandler) gBrowserStatusHandler.destroy();
}

function loadURI(uri)
{
  gBrowser.webNavigation.loadURI(uri, nsIWebNavigation.LOAD_FLAGS_ALLOW_THIRD_PARTY_FIXUP, null, null, null);
}

function back()
{ 
    try {   
      if (gBrowser.webNavigation.canGoBack)
          gBrowser.webNavigation.goBack();
    } catch(i) { alert(i) } 

}

function forward()
{
  gBrowser.webNavigation.goForward();
}

function stop()
{
  gBrowser.webNavigation.stop(nsIWebNavigation.STOP_ALL);
  document.getElementById("load").image = "image/refresh.png"; 
  document.getElementById("load").command = "cmd_BrowserGo"; 

  browserPan();
}

function zoomOut()
{
  gBrowser.zoomController.scale = gBrowser.markupDocumentViewer.fullZoom / 1.2;
}

function zoomIn()
{
  gBrowser.zoomController.scale = gBrowser.markupDocumentViewer.fullZoom * 1.2;    
}


function BrowserReload()
{
  gBrowser.webNavigation.reload(nsIWebNavigation.LOAD_FLAGS_NONE);
}


function go()
{
  try
  {
    loadURI(gURLBar.value);
  }
  catch(ex) {alert(ex);}

  var elem=document.getElementById('title');
  elem.setAttribute('hidden','false');
  
  var elem=document.getElementById('urlToolBar');
  elem.setAttribute('hidden','false');

  var elem=document.getElementById('urlToolBar');
  elem.setAttribute('hidden','false');
  
  hideBookmarks();  // not clean, will be fixed

  elem=document.getElementById('load');
  elem.setAttribute('hidden','false');

  elem=document.getElementById('bm');
  elem.setAttribute('hidden','false');

  elem=document.getElementById('commandDeck');
  elem.setAttribute('selectedIndex','0');

  elem=document.getElementById('sysKeyboard');
  elem.setAttribute('hidden','true');

  return true;
}

function tab()
{
  try
  {
      alert ("ToDo - Multiple Windows");
      //window.QueryInterface(nsIDOMChromeWindow).browserDOMWindow.openURI(null,null,null,null);
  }
  catch(ex) {alert(ex);}
  
  return true;
}

var title_visible = "true";

function title_click()
{
    var elem = document.getElementById("urltoolbar");

    if (title_visible == "true")
    {
        elem.setAttribute('hidden','true');
        title_visible = "false";
    }
    else
    {
        elem.setAttribute('hidden','false');
        title_visible = "true";
    }
}

function nsBrowserAccess()
{
}

nsBrowserAccess.prototype =
{
  QueryInterface : function(aIID)
  {
    if (aIID.equals(nsIBrowserDOMWindow) ||
        aIID.equals(nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },
  
  openURI : function(aURI, aOpener, aWhere, aContext)
  {
    var url = aURI ? aURI.spec : "about:blank";
    var newTab     = gBrowser.addTab(url);
    var newWindow  = gBrowser.getBrowserForTab(newTab).docShell
                             .QueryInterface(nsIInterfaceRequestor)
                             .getInterface(nsIDOMWindow);
    return newWindow;
  },
  
  isTabContentWindow : function(aWindow)
  {
    var browsers = gBrowser.browsers;
    for (var ctr = 0; ctr < browsers.length; ctr++)
      if (browsers.item(ctr).contentWindow == aWindow)
        return true;
    return false;
  }
}


function getWebNavigation()
{
  try {
    return gBrowser.webNavigation;
  } catch (e) {
    return null;
  }
}

/* Prototype PAN */ 

function browserPan() {
  if(!gBrowser.contentWindow.gInPan) {  

    gBrowser.contentDocument.addEventListener("mousedown",browserPanMouseHandler,true);
    gBrowser.contentDocument.addEventListener("mouseup",browserPanMouseHandlerDestroy,true);
    gBrowser.contentDocument.addEventListener("click",browserPanMouseHandlerPanNull,true);
    gBrowser.contentDocument.addEventListener("dblclick", browserDoubleClick, true);
    gBrowser.contentWindow.gInPan=true;
  } 
    /*
    else {
    gBrowser.contentDocument.removeEventListener("mousedown",browserPanMouseHandler,true);
    gBrowser.contentDocument.removeEventListener("mouseup",browserPanMouseHandlerDestroy,true);
    gBrowser.contentDocument.removeEventListener("click",browserPanMouseHandlerPanNull,true);
    gBrowser.contentWindow.gInPan=false;
        alert ("browserPan - else");
  }
    */
}

var gInPan=false;
var gPanY=-1;
var gPanX=-1;
var gInitialPanX=null;
var gInitialPanY=null;
var gHandler=null;
var gFingerDistance;
var gScreenX,gScreenY;

function browserPanMouseHandler(e) {

  if (e.target instanceof HTMLInputElement)
  {
      return;
  }

  gHandler = e.button != 2 ? browserPanMouseHandlerPan : browserPanMouseHandlerZoom;
  gBrowser.contentDocument.addEventListener("mousemove", gHandler, true); 
  gPanY=e.clientY;
  gPanX=e.clientX;
  
  e.preventDefault();
  e.stopPropagation();
  gInitialPanY=gPanY;
  gInitialPanX=gPanX;
  gScreenX = e.screenX;
  gScreenY = e.screenY;
  gFingerDistance = 100;
}

function browserPanMouseHandlerPan(e) {
  panDeltaY=gPanY-e.clientY;
  panDeltaX=gPanX-e.clientX;
  
  gBrowser.contentWindow.scrollBy(0,panDeltaY);
  gBrowser.contentWindow.scrollBy(panDeltaX,0);

  gPanY=e.clientY;
  gPanX=e.clientX;
}

function browserPanMouseHandlerZoom(e) {
  var deltaX = e.screenX - gScreenX + 100;
  var deltaY = e.screenY - gScreenY;
  var newDist = Math.sqrt(Math.pow(deltaX, 2) + Math.pow(deltaY, 2));
  var scale = newDist / gFingerDistance;
  if (e.screenX < gScreenX && scale > 1)
    scale = 1 / scale;
  var newZoom = scale * gBrowser.markupDocumentViewer.fullZoom;
//  dump("dist: " + newDist + " newZoom: " + newZoom + "\n");
  gFingerDistance = Math.max(0.1, newDist);
  gBrowser.zoomController.scale = newZoom;
}

function browserPanMouseHandlerPanNull(e) {
    //e.preventDefault();
}

function browserPanMouseHandlerDestroy(e) {
  gBrowser.contentDocument.removeEventListener("mousemove",gHandler,true);
  
  if (e.target instanceof HTMLInputElement)
  {
      return;
  }

  e.preventDefault();
  e.stopPropagation();
  if(e.clientY==gInitialPanY || e.clientX==gInitialPanX) {
  browserPan();
  }
}

function browserDoubleClick(e) {
  // find the target by walking the dom.
  // we want to zoom in on the block elements
  var initTarget = e.explicitOriginalTarget;
  while (initTarget && initTarget.nodeName != "HTML")
  {
    var disp = window.getComputedStyle(initTarget, "").getPropertyValue("display");
//    dump(initTarget.nodeName + " " + initTarget.nodeType +  " " + disp + "x\n");
    if (disp.match(/(block|inline-block|list-item|table)/g))
    {
      gBrowser.zoomController.revealElement(initTarget);
      break;
    }
    else
      initTarget = initTarget.parentNode;
  }
}
function enterURL()
{

  elem=document.getElementById('title');
  elem.setAttribute('hidden','true');
  
  var elem=document.getElementById('load');
  elem.setAttribute('hidden','true');

  elem=document.getElementById('bm');
  elem.setAttribute('hidden','true');
 
  elem=document.getElementById('commandDeck');
  elem.setAttribute('selectedIndex','1');
  
  hideBookmarks();  // not clean, will be fixed
 
  elem=document.getElementById('sysKeyboard');
  elem.setAttribute('hidden','false');
 
}

function initButtons()
{
  var elem=document.getElementById('load');
  elem.setAttribute('hidden','false');

  elem=document.getElementById('title');
  elem.setAttribute('hidden','false');
  
  elem=document.getElementById('bm');
  elem.setAttribute('hidden','false');

  elem=document.getElementById('commandDeck');
  elem.setAttribute('selectedIndex','0');
  
  elem=document.getElementById('sysKeyboard');
  elem.setAttribute('hidden','true');
}

function hideShow()
{
  var elem=document.getElementById('urlToolBar');
  var hiddenVar = elem.getAttribute('hidden');

  if (hiddenVar == "true")
  {
    elem.setAttribute('hidden','false');
  }
  else
  {
    elem.setAttribute('hidden','true');
    hideBookmarks();
  }
  
  var elem=document.getElementById('load');
  elem.setAttribute('hidden','false');

  elem=document.getElementById('bm');
  elem.setAttribute('hidden','false');

  elem=document.getElementById('commandDeck');
  elem.setAttribute('selectedIndex','0');
  
  elem=document.getElementById('sysKeyboard');
  elem.setAttribute('hidden','true');


}


function showBookmarks()
{
  var elem=document.getElementById('bookmarkList');
  var hiddenParm = elem.getAttribute('hidden');

  if (hiddenParm == "true")
    elem.setAttribute('hidden','false');
  else
    elem.setAttribute('hidden','true');
}

function hideBookmarks()
{
  var elem=document.getElementById('bookmarkList');
  elem.setAttribute('hidden','true');
}

function selectBookmark(event)
{

  var elem=document.getElementById('bookmarkList');
  
  elem.setAttribute('hidden','true');

  var item=elem.getAttribute('selectedItem');


  var itemName=item.getAttribute('label');
  
}
